diff --git a/bgpd/bgp_nexthop.c b/bgpd/bgp_nexthop.c
index 76bfa73feeb..e357cfcc09b 100644
--- a/bgpd/bgp_nexthop.c
+++ b/bgpd/bgp_nexthop.c
@@ -251,6 +251,22 @@ static void bgp_address_del(struct bgp *bgp, struct prefix *p)
 	}
 }
 
+/* Verify if the bgp router ID is in the address hash table */
+int bgp_router_id_valid(struct bgp *bgp)
+{
+	struct bgp_addr tmp;
+	struct bgp_addr *addr;
+
+	tmp.addr = bgp->router_id;
+	addr = hash_lookup(bgp->address_hash, &tmp);
+	if(addr == NULL) {
+		if (BGP_DEBUG(zebra, ZEBRA))
+			zlog_debug("%s : RTR ID %s not active",
+				__func__, inet_ntoa(bgp->router_id));
+		return -1;
+	}
+	return 0;
+}
 
 struct bgp_connected_ref {
 	unsigned int refcnt;
diff --git a/bgpd/bgp_nexthop.h b/bgpd/bgp_nexthop.h
index a771bead230..b5316e6b5cd 100644
--- a/bgpd/bgp_nexthop.h
+++ b/bgpd/bgp_nexthop.h
@@ -102,5 +102,5 @@ extern void bgp_tip_add(struct bgp *bgp, struct in_addr *tip);
 extern void bgp_tip_del(struct bgp *bgp, struct in_addr *tip);
 extern void bgp_tip_hash_init(struct bgp *bgp);
 extern void bgp_tip_hash_destroy(struct bgp *bgp);
-
+extern int bgp_router_id_valid(struct bgp *bgp);
 #endif /* _QUAGGA_BGP_NEXTHOP_H */
diff --git a/bgpd/bgpd.c b/bgpd/bgpd.c
index 82da0245b5c..1dc77735904 100644
--- a/bgpd/bgpd.c
+++ b/bgpd/bgpd.c
@@ -270,6 +270,7 @@ void bgp_router_id_zebra_bump(vrf_id_t vrf_id, const struct prefix *router_id)
 {
 	struct listnode *node, *nnode;
 	struct bgp *bgp;
+	struct in_addr *prefix = (struct in_addr *)&router_id->u.prefix4;
 
 	if (vrf_id == VRF_DEFAULT) {
 		/* Router-id change for default VRF has to also update all
@@ -278,17 +279,31 @@ void bgp_router_id_zebra_bump(vrf_id_t vrf_id, const struct prefix *router_id)
 			if (bgp->inst_type == BGP_INSTANCE_TYPE_VRF)
 				continue;
 
-			bgp->router_id_zebra = router_id->u.prefix4;
-			if (!bgp->router_id_static.s_addr)
-				bgp_router_id_set(bgp, &router_id->u.prefix4);
+			bgp->router_id_zebra = *prefix;
+			if (!bgp->router_id_static.s_addr) {
+				if(bgp_router_id_valid(bgp) < 0) {
+					if (BGP_DEBUG(zebra, ZEBRA))
+						zlog_debug("RID change : vrf %d, RTR ID %s",
+							bgp->vrf_id,
+							inet_ntoa(*prefix));
+					bgp_router_id_set(bgp, prefix);
+				}
+			}
 		}
 	} else {
 		bgp = bgp_lookup_by_vrf_id(vrf_id);
 		if (bgp) {
-			bgp->router_id_zebra = router_id->u.prefix4;
-
-			if (!bgp->router_id_static.s_addr)
-				bgp_router_id_set(bgp, &router_id->u.prefix4);
+			bgp->router_id_zebra = *prefix;
+
+			if (!bgp->router_id_static.s_addr) {
+				if(bgp_router_id_valid(bgp) < 0) {
+					if (BGP_DEBUG(zebra, ZEBRA))
+						zlog_debug("RID change : vrf %d, RTR ID %s",
+							bgp->vrf_id,
+							inet_ntoa(*prefix));
+					bgp_router_id_set(bgp, prefix);
+				}
+			}
 		}
 	}
 }
diff --git a/zebra/redistribute.c b/zebra/redistribute.c
index e3101fbe72c..12ee9c5cfff 100644
--- a/zebra/redistribute.c
+++ b/zebra/redistribute.c
@@ -449,14 +449,13 @@ void zebra_interface_address_add_update(struct interface *ifp,
 
 	zebra_vxlan_add_del_gw_macip(ifp, ifc->address, 1);
 
-	router_id_add_address(ifc);
-
 	for (ALL_LIST_ELEMENTS(zebrad.client_list, node, nnode, client))
 		if (CHECK_FLAG(ifc->conf, ZEBRA_IFC_REAL)) {
 			client->connected_rt_add_cnt++;
 			zsend_interface_address(ZEBRA_INTERFACE_ADDRESS_ADD,
 						client, ifp, ifc);
 		}
+	router_id_add_address(ifc);
 }
 
 /* Interface address deletion. */
@@ -478,14 +477,13 @@ void zebra_interface_address_delete_update(struct interface *ifp,
 
 	zebra_vxlan_add_del_gw_macip(ifp, ifc->address, 0);
 
-	router_id_del_address(ifc);
-
 	for (ALL_LIST_ELEMENTS(zebrad.client_list, node, nnode, client))
 		if (CHECK_FLAG(ifc->conf, ZEBRA_IFC_REAL)) {
 			client->connected_rt_del_cnt++;
 			zsend_interface_address(ZEBRA_INTERFACE_ADDRESS_DELETE,
 						client, ifp, ifc);
 		}
+	router_id_del_address(ifc);
 }
 
 /* Interface VRF change. May need to delete from clients not interested in
